//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "SplitPanel.h"
#include "Unit1.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)

__fastcall TSplitPanel::TSplitPanel(TComponent* Owner,DWORD *act)
        : TPanel(Owner)
{
  Active = (DWORD*)act;
  Panel1 = NULL;
  Panel2 = NULL;
  Splitter = NULL;
  Caption = "AAA";

  PaintBox = new TPaintBox(Owner);
  if (PaintBox)
  {
    PaintBox->Parent = this;
    PaintBox->Align = alClient;
    PaintBox->OnMouseDown = PaintBoxMouseDown;
    PaintBox->OnPaint = PaintBox1Paint;
  }
}

void TSplitPanel::Split(TObject *Sender,int align,float percent)
{
  SplitP = percent;
  Panel1 = new TSplitPanel(Owner,(DWORD*)Active);
  if (Panel1)
  {
    Panel1->Parent = this;
    Panel1->Align = align;
    Panel1->Caption = "AAA";
    Panel1->Width = Width*SplitP;
//    Panel1->Height = Height*SplitP;
// N PaintBox Ƴ] Panel1->PaintBox;
// AR
    delete PaintBox;
    PaintBox = NULL;
  }

  Splitter = new TSplitter(Owner);
  if (Splitter)
  {
    Splitter->Parent = this;
    Splitter->Align = align;

    Splitter->Top = Panel1->Top+Panel1->Height;
    Splitter->Left = Panel1->Left+Panel1->Width;

    Splitter->OnCanResize = SplitterCanResize;
  }

  Panel2 = new TSplitPanel(Owner,Active);
  if (Panel2)
  {
    Panel2->Parent = this;
    Panel2->Align = alClient;
    Panel2->Caption = "BBB";
  }

  SplitPanelResize(Sender);
}

__fastcall TSplitPanel::~TSplitPanel()
{
  if (Panel1) delete Panel1;
  if (Panel2) delete Panel2;
  if (Splitter) delete Splitter;
  if (PaintBox) delete PaintBox;
}

void TSplitPanel::SplitPanelResize(TObject *Sender)
{
  if (Panel1 && Splitter)
  {
    if (Splitter->Align == alTop || Splitter->Align == alBottom)  //
    {
      Panel1->Height = Height*SplitP;
    } else  //
    {
      Panel1->Width = Width*SplitP;
    }
    Panel1->SplitPanelResize(Sender);

//קKYܤpSjδζ]Wh
    Splitter->Top = Panel1->Top+Panel1->Height;
    Splitter->Left = Panel1->Left+Panel1->Width;

    if (Panel2) Panel2->SplitPanelResize(Sender);
  }
}

void TSplitPanel::PaintRect(TColor c)
{
  if (PaintBox)
  {
    PaintBox->Canvas->Pen->Color = c;
//
    PaintBox->Canvas->MoveTo(0,0);
    PaintBox->Canvas->LineTo(PaintBox->Width-1,0);
    PaintBox->Canvas->LineTo(PaintBox->Width-1,PaintBox->Height-1);
    PaintBox->Canvas->LineTo(0,PaintBox->Height-1);
    PaintBox->Canvas->LineTo(0,0);
  }
}

void __fastcall TSplitPanel::PaintBoxMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
  ((TSplitPanel*)*Active)->PaintRect(clWhite);  //
  *Active = (DWORD)this;
  PaintRect(clRed);  //ܱRO
}

void TSplitPanel::Delete(TObject *Sender)
{
  AnsiString ss = Parent->ClassName();
  if (ss == "TSplitPanel")
  {
    if (PaintBox)
    {
      delete PaintBox;
      PaintBox = NULL;
    }

    TSplitPanel *p = (TSplitPanel *)Parent;

    if (p->Panel1 && p->Panel1->PaintBox)
    {
      if (p->PaintBox == NULL)
      {
        p->PaintBox = p->Panel1->PaintBox;
        p->PaintBox->Parent = p;
        p->PaintBox->OnMouseDown = p->PaintBoxMouseDown;
        p->PaintBox->OnPaint = p->PaintBox1Paint;
        p->Panel1->PaintBox = NULL;
      }
      if (p->Panel1)
      {
        delete p->Panel1;
        p->Panel1 = NULL;
      }
      if (p->Panel2)
      {
        delete p->Panel2;
        p->Panel2 = NULL;
      }
      if (p->Splitter)
      {
        delete p->Splitter;
        p->Splitter = NULL;
      }
      *Active = (DWORD)p;
      return;
    } else
    {
      if (p->Panel1->Panel1)  //t@ӵ2ӹ,hݦAR@Panel
      {
        TSplitPanel *pp1 = p->Panel1;
        TSplitPanel *pp2 = p->Panel2;
        TSplitter *pps = p->Splitter;
        TPaintBox *ppp = p->PaintBox;

        p->Panel1 = pp1->Panel1;
        p->Panel1->Align = pp1->Panel1->Align;
        p->Panel1->Parent = p;
        p->Panel2 = pp1->Panel2;
        p->Panel2->Parent = p;
        p->Splitter = pp1->Splitter;
        p->PaintBox = pp1->PaintBox;
        p->SplitP = pp1->SplitP;
//        p->Align = alClient;

        if (p->PaintBox)
        {
          p->PaintBox->Parent = p;
          p->PaintBox->OnMouseDown = PaintBoxMouseDown;
          p->PaintBox->OnPaint = PaintBox1Paint;
        }
        if (p->Splitter)
        {
          p->Splitter->Parent = p;
          p->Splitter->Top = p->Panel1->Top+p->Panel1->Height;
          p->Splitter->Left = p->Panel1->Left+p->Panel1->Width;
          p->Splitter->Align = pp1->Panel1->Align;
          p->Splitter->OnCanResize = p->SplitterCanResize;
        }

        *Active = (DWORD)p->Panel1;

        if (pp1)
        {
          pp1->Panel1 = NULL;
          pp1->Panel2 = NULL;
          pp1->Splitter = NULL;
          pp1->PaintBox = NULL;
          delete pp1;
        }

        if (pp2)
        {
          delete pp2;
        }

        if (pps)
        {
          delete pps;
        }

        if (ppp)
        {
          delete ppp;
        }

        return;
      }
    }

    if (p->Panel2 && p->Panel2->PaintBox)
    {
      if (p->PaintBox == NULL)
      {
        p->PaintBox = p->Panel2->PaintBox;
        p->PaintBox->Parent = p;
        p->PaintBox->OnMouseDown = p->PaintBoxMouseDown;
        p->PaintBox->OnPaint = p->PaintBox1Paint;
        p->Panel2->PaintBox = NULL;
      }
      if (p->Panel1)
      {
        delete p->Panel1;
        p->Panel1 = NULL;
      }
      if (p->Panel2)
      {
        delete p->Panel2;
        p->Panel2 = NULL;
      }
      if (p->Splitter)
      {
        delete p->Splitter;
        p->Splitter = NULL;
      }
      *Active = (DWORD)p;
      return;
    } else
    {
      if (p->Panel2->Panel1)  //t@ӵ2ӹ,hݦAR@Panel
      {
        TSplitPanel *pp1 = p->Panel1;
        TSplitPanel *pp2 = p->Panel2;
        TSplitter *pps = p->Splitter;
        TPaintBox *ppp = p->PaintBox;

        p->Panel1 = pp2->Panel1;
        p->Panel1->Align = pp2->Panel1->Align;
        p->Panel1->Parent = p;
        p->Panel2 = pp2->Panel2;
        p->Panel2->Parent = p;
        p->Splitter = pp2->Splitter;
        p->PaintBox = pp2->PaintBox;
        p->SplitP = pp2->SplitP;
//        p->Align = alClient;

        if (p->PaintBox)
        {
          p->PaintBox->Parent = p;
          p->PaintBox->OnMouseDown = p->PaintBoxMouseDown;
          p->PaintBox->OnPaint = p->PaintBox1Paint;
        }
        if (p->Splitter)
        {
          p->Splitter->Parent = p;
          p->Splitter->Top = p->Panel1->Top+p->Panel1->Height;
          p->Splitter->Left = p->Panel1->Left+p->Panel1->Width;
          p->Splitter->Align = pp2->Panel1->Align;
          p->Splitter->OnCanResize = p->SplitterCanResize;
        }

        *Active = (DWORD)p->Panel1;

        if (pp1)
        {
          delete pp1;
        }

        if (pp2)
        {
          pp2->Panel1 = NULL;
          pp2->Panel2 = NULL;
          pp2->Splitter = NULL;
          pp2->PaintBox = NULL;
          delete pp2;
        }

        if (pps)
        {
          delete pps;
        }

        if (ppp)
        {
          delete ppp;
        }

        return;
      }
    }
  }
}

void __fastcall TSplitPanel::SplitterCanResize(TObject *Sender, int &NewSize, bool &Accept)
{
  if (Splitter)
  {
    if (Splitter->Align == alTop || Splitter->Align == alBottom)
    {
      if (Height > 0) SplitP = (float)NewSize/Height;
    } else
    {
      if (Width > 0) SplitP = (float)NewSize/Width;
    }  
  }
}

void __fastcall TSplitPanel::PaintBox1Paint(TObject *Sender)
{
  if (*Active == (DWORD)this) PaintRect(clRed);  //ثeRO
}

__fastcall TMainPanel::TMainPanel(TComponent* Owner)
        : TWinControl(Owner)
{
  BasePanel = new TSplitPanel(Owner);
  if (BasePanel)
  {
    BasePanel->Active = (DWORD*)&ActivePanel;
    BasePanel->Parent = this;
    BasePanel->Align = alClient;
    BasePanel->Caption = "BASEPANEL";
  }
  ActivePanel = BasePanel;
}

__fastcall TMainPanel::~TMainPanel()
{
  if (BasePanel) delete BasePanel;
}

void TMainPanel::Split(TObject *Sender,int align,float percent)
{
  ActivePanel->Split(Sender,align,percent);
  if (ActivePanel->Panel1)
  {
    ActivePanel = ActivePanel->Panel1;
    ActivePanel->PaintRect(clRed);
  }
}

void TMainPanel::SplitPanelResize(TObject *Sender)
{
  if (BasePanel)
  {
    BasePanel->SplitPanelResize(Sender);
    if (BasePanel->Panel1) BasePanel->Panel1->SplitPanelResize(Sender);
    if (BasePanel->Panel2) BasePanel->Panel2->SplitPanelResize(Sender);
  }
}

void TMainPanel::Delete(TObject *Sender)
{
  ActivePanel->Delete(Sender);
  SplitPanelResize(Sender);
}


