//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
TMemo *Memo = NULL;
TStringGrid *StringGrid = NULL;

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
  MainPanel = NULL;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button1Click(TObject *Sender)
{
  if (MainPanel) return;

  MainPanel = new TMainPanel(Panel2);
  if (MainPanel)
  {
    MainPanel->Parent = this;
    MainPanel->Align = alClient;
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button2Click(TObject *Sender)
{
  if (MainPanel)
  {
    MainPanel->Split(Sender,alTop,0.5);
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Panel2Resize(TObject *Sender)
{
  if (MainPanel)
  {
    MainPanel->SplitPanelResize(Sender);
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button3Click(TObject *Sender)
{
  if (MainPanel)
  {
    MainPanel->Split(Sender,alLeft,0.5);
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button4Click(TObject *Sender)
{
  if (MainPanel)
  {
    MainPanel->Delete(Sender);
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button5Click(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button6Click(TObject *Sender)
{
  if (MainPanel && Memo == NULL)
  {
    Memo = new TMemo(MainPanel->ActivePanel->Owner);
    if (Memo)
    {
      Memo->Align = alClient;
      Memo->Parent = MainPanel->ActivePanel;
    }
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormClose(TObject *Sender, TCloseAction &Action)
{
  if (Memo) delete Memo;
  if (StringGrid) delete StringGrid;
  if (MainPanel) delete MainPanel;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button7Click(TObject *Sender)
{
  if (MainPanel && StringGrid == NULL)
  {
    StringGrid = new TStringGrid(MainPanel->ActivePanel->Owner);
    if (StringGrid)
    {
      StringGrid->Align = alClient;
      StringGrid->Parent = MainPanel->ActivePanel;
    }
  }
}
//---------------------------------------------------------------------------

